/******************************************************************************
* To the extent possible under law, Sebastian Roith
* <https://www.roith-unterrichtet.de> has waived all copyright and related or
* neighboring rights to this script. This work is published from Germany.
******************************************************************************/

/**
* Daten eines anzeigbaren Rechtecks
*/
function RectDataBuilder() {
    this._attributes = [
        new AttributeNumber('oben', -1, 6, 1),
        new AttributeNumber('links', -1, 10, 1),
        new AttributeNumber('breite', 0, 10, 1),
        new AttributeNumber('hoehe', 0, 10, 1),
        new AttributeNumber('abrundung', 0, 1, 2),
        new AttributeColor('fuellung', true),
        new AttributeColor('umrandung', true),
        new AttributeNumber('strichdicke', 0, 10, 1)
    ];
    this._attributes[2].defaultValue = 1;
    this._attributes[3].defaultValue = 1;
    this._attributes[7].defaultValue = 0.1;
}

// Alle Attribute
RectDataBuilder.prototype._attributes = [];

/**
* Alle Attributnamen ermitteln
* @return Array     Attributnamen als Strings
*/
RectDataBuilder.prototype.getAttributeNames = function() {
    return this._attributes.map(function(item) { return item.attributeName; });
}

/**
* Eingegebene Attributwerte in tatsächliche Attributwerte umwandeln
* @return Object    Objekt mit Attributen message (Fehlermeldung, falls vorhanden) und object (Objekt mit tatsächlichen Attributwerten)
*/
RectDataBuilder.prototype.createFromAtts = function(
    atts        // Eingegebene Attributwerte
) {
    var obj = {};
    var s;
    for (var n = 0; n < this._attributes.length; ++n) {
        if (s = this._attributes[n].readValue(atts[this._attributes[n].attributeName], obj))
            return { message: s, object: obj };
    }
    return { message: '', object: obj };
}
